package com.sjls.nstthh;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

public class TestThread {
    volatile static boolean isHeartbeat = true,onlyOnce=false, isReceive = false;
    private volatile static List<String> sendData = Collections.synchronizedList(new ArrayList<String>());



    public static void main(String[] args) {


        Thread t1 = new Thread() {


            public void run() {

                while (true) {

                        synchronized (this) {
                            System.out.println("t1 = 1111111" + isReceive);
                            isReceive = true;

                        }


                        wait10Seconds(1000);


                }
            }
        };
        t1.start();


        Thread t2 = new Thread() {

            public void run() {

                while (!Thread.interrupted()) {

//                    wait10Seconds(2000);
//                    System.out.println("1111 = " + 111111);

                    if (isHeartbeat && isReceive || wait10Seconds(10000)) {
                        if (sendData.size() > 0) {
                            Iterator<String> iterator = sendData.iterator();
                            if (iterator.hasNext()) {

                                synchronized (this) {
                                    System.out.println("t2 = 2222" + isReceive);
                                    iterator.remove();
                                    isReceive = false;
                                }

                            }
                        }
                    } else {
                        Thread.currentThread().interrupt();

                    }

                      wait10Seconds(2000);

                }
            }
        };
        t2.start();


    }


    public final static boolean wait10Seconds(long m) {
        try {
            Thread.sleep(m);
        } catch (InterruptedException e) {
        }
        return true;
    }
}
